function TimelineController(){
	var self = this; self.name = "TimelineController"; // MANDATORY

    this.data = null;
    this.future_data = false;
    this.conditional = new ConditionalController();
    this.synchronizer = false;
    this.renderer = null;
    this.timer = null;
    this.security_timer = null;

    this.index = 0;
    this.timeline = null;
    this.line = null;
    this.last_time = 0;
    this.toberendered = 0;

    this.template = false;
    this.rendering = false;
    this.scene = false;
    this.pass = 1;
    this.playlist_id = 0;
    this.active = false;

    this.prepared = false;
		this.first_run = true;
		this.previous_current_time = 0;
		
		this.player_id = 0;
		if(typeof(id) !== "undefined"){
			this.player_id = id;
		}

    this.setDataManager = function(DataManagerController){
        self.data = DataManagerController;
    };

    this.setRenderer = function(DisplayController){
        self.renderer = null;
        self.renderer = DisplayController;
        self.rendering = {content:{reference:self.renderer.emergency_ref},template:false};
    };

    this.build = function(){
        var list = $(self.data.reader.archive()).find("files");
        for(var i=0;i<list.length;i++){
            var content_id = self.execute(function(){return $(list[i]).attr("id");});
            var content = self.data.getArchiveFileItemById(content_id);
            if(content){
                self.addContent(content);
            }
        }
				setTimeout(function(e){
					// Delay start playlist for async filesystems
					$(self).trigger("TimelineControllerReady");
				},1500);
    };

    this.unload = function(){
        self.stop();
        self.renderer.clear();
        self.timeline = null;
        self.renderer = null;
        self.data = null;
        self.future_data = null;
    };

    this.update = function(data){
        self.log("<<<<<<< UPDATE >>>>>>");
        if(typeof(data) !== "undefined"){
            self.log("updating xml data .... ");
            self.data = null;
            self.data = data;
        }
        self.timeline = null;
        self.timeline = $(self.data.reader.timeline()).find("content");
        self.build();
				self.notifyError(self.ERROR['EXCEPTION'],self.name+" ["+(new Date().getTime())+"] | ["+self.getDate().getTime()+" - "+self.getDate().getTimezoneOffset()+"]: Updating XML Data");
        if(self.platform !== "WEB" && self.platform !== "ONLINE"){
					self.prepare_next_day();
	      }
				

				var config = self.data.getConfig();
				var player_mode = config.getMode();
				if(player_mode == 2 || player_mode == 3){
						if(!self.synchronizer){
								self.synchronizer = new SynchronizerController(self.player_id);
								self.conditional.synchronizer = self.synchronizer;
								$(self.synchronizer).on("onSyncChangeMode",self.onSyncModeChanged);
						}
						self.synchronizer.update(player_mode,config.getSyncPort(),config.getSyncMachines());
						if(self.synchronizer){
							$(self.synchronizer).off("on"+self.name+"SyncRecieve",self.onSyncRecieve);
							$(self.synchronizer).off("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
							$(self.synchronizer).off("onStatusSyncRecieve",self.onStatusSyncRecieve);
							$(self.synchronizer).on("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
							if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
									$(self.synchronizer).on("on"+self.name+"SyncRecieve",self.onSyncRecieve);
							}else if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
									$(self.synchronizer).on("onStatusSyncRecieve",self.onStatusSyncRecieve);
							}
						}
				}
				
				var data_conditions = self.data.getConditions();
        if(data_conditions){
            $(self.conditional).off("ConditionTrigger",self.onConditionTrigger);
            $(self.conditional).on("ConditionTrigger",self.onConditionTrigger);
            self.conditional.update(data_conditions);
        }
    };

    this.main = function(use_timer){
				var timer_enabled = true;
				if(typeof(use_timer) !== "undefined"){
					timer_enabled = use_timer;
				}
				self.OS.busy = true;
        self.prepared = false;
        //self.log("TIMELINE RENDER ---- Default Content : "+self.renderer.getDefaultDisplayReference()+" To Be Rendered : "+self.scene.content.reference);
        //self.setBenchmarkStart(true); /// ENABLE OR DISABLE BENCHMARK
				//self.log("Benchmark : Render Scene Start");
				if(self.previous_current_time > 0){
					self.log("Start has previous time : "+self.previous_current_time);
					self.scene.content.controller[self.scene.switcher].start_current_time = self.previous_current_time;
					self.previous_current_time = 0;
				}
				self.rendering = self.renderer.render_scene(self.scene,self.rendering);
				//self.getBenchmark("Render Scene End");
				if(self.synchronizer){
						if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
								self.log("Master Send Broadcast Play !! index = "+self.index);
								var broadcast_message = {
									sender:self.name,
									action:{
										do:"play",
										index:self.last_time,
										duration:self.scene.content.content.getDuration(),
										time:self.getDate().getTime(),
										player_id:self.player_id
									}
								};
								self.synchronizer.broadcast(broadcast_message);
								broadcast_message = null;
						}
				}
        self.reportStatus();
        /// security timer
        clearTimeout(self.security_timer);
				if(timer_enabled){
					var security_time = parseInt(self.scene.content.content.getDuration()/2)*1000;
	        if(security_time < 5000){security_time = 5000;}
					self.log("Activating security timer with delay_time : "+security_time);
	        self.security_timer = setTimeout(self.check_rendering_execution,security_time);
				}
    };

    this.check_rendering_execution = function(){
				self.log("Check for security");
        clearTimeout(self.security_timer);
        if(!self.prepared){
						self.log("Content is NOT prepared");
            self.prepare();
						self.log(self.ERROR['TIMELINE_CONTROLLER']+2,self.name+" : Content "+self.scene.content.reference+" could not load properly... force prepare next content. ");
            self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+2,self.name+" : Content "+self.scene.content.reference+" could not load properly... force prepare next content. ");
        }else{
					self.log("Content IS prepared");
				}
    };

    this.start = function(){
        self.stop();
        self.active = true;
        self.pass = 0;
        self.log("<<<<<<< START >>>>>>");
        self.timeline = $(self.data.reader.timeline()).find("content");
        var date = self.getDate();
        if(self.server_time_activated){
            self.last_time = (date.getUTCHours()*60*60) + (date.getUTCMinutes()*60) + date.getUTCSeconds();
        }else{
            self.last_time = (date.getHours()*60*60) + (date.getMinutes()*60) + date.getSeconds();
        }
        $(self.renderer).on("DisplayControllerElementStarted",self.prepare);
        $(self.renderer).on("DisplayControllerElementError",self.onDisplayControllerElementError);
        if(self.rendering.content.reference == self.renderer.emergency_ref || self.rendering.content.reference == self.renderer.default_ref){
            self.scene = null;
            self.scene = self.renderer.prepare_scene(false,self.renderer.getDefaultDisplayReference(),false);
            self.rendering = self.renderer.render_scene(self.scene,false);
        }else{
            self.prepare();
        }
    };

    this.onSystemTimeUpdate = function(event,before,after){
        self.log("<<<<<<< UPDATE SYSTEM TIME >>>>>>");
        var date = self.getDate();
        if(self.server_time_activated){
            self.last_time = (date.getUTCHours()*60*60) + (date.getUTCMinutes()*60) + date.getUTCSeconds();
        }else{
            self.last_time = (date.getHours()*60*60) + (date.getMinutes()*60) + date.getSeconds();
        }
        self.prepare();
    };

    this.onDisplayControllerElementError = function(e){
        self.scene = null;
        self.scene = self.renderer.prepare_scene(false,self.renderer.getDefaultDisplayReference(),false);
        self.rendering = self.renderer.render_scene(self.scene,self.rendering);
    };

    this.prepare = function(e,sync_time){
				var synchronizer_time = -1;
				if(typeof(sync_time) !== "undefined"){
					synchronizer_time = sync_time;
				}
        clearTimeout(self.security_timer);
        //self.reportStatus();
        if(self.renderer !== null){
            self.toberendered = self.renderer.getDefaultDisplayReference();
        }else{
            self.toberendered = 0;
        }

        self.log("<<<<<<< PREPARE >>>>>>");
        var date = self.getDate();
        var time = 0;
        if(self.server_time_activated){
            time = (date.getUTCHours()*60*60) + (date.getUTCMinutes()*60) + date.getUTCSeconds();
        }else{
            time = (date.getHours()*60*60) + (date.getMinutes()*60) + date.getSeconds();
        }
        time += 1; // round up milliseconds
        var seconds_to_time = new Date(1970,0,1);
				var milliseconds_of_the_day = time * 1000 + date.getMilliseconds();

        seconds_to_time.setUTCSeconds(time);
        var now_time = seconds_to_time.getHours()+":"+seconds_to_time.getMinutes()+":"+seconds_to_time.getSeconds();
        self.log("Benchmark Now : "+now_time+"."+seconds_to_time.getMilliseconds()+" MoD :"+milliseconds_of_the_day);
        seconds_to_time = new Date(1970,0,1);
        seconds_to_time.setUTCSeconds(self.last_time);
        var in_time = seconds_to_time.getHours()+":"+seconds_to_time.getMinutes()+":"+seconds_to_time.getSeconds();

				if(synchronizer_time >= 0){
					time = synchronizer_time;
				}
				if(self.first_run){
					self.first_run = false;
					self.line = $(self.timeline).filter(function(i){return $(this).attr('end') > time;}).eq(0);
					var adjustment =  time - parseInt(self.line.attr("start"));
					//console.log("Start :"+self.line.attr("start")+" --- Now : "+time+" --- Adjust : "+adjustment);
					//console.log(upper);
					self.previous_current_time = adjustment*1000;
					$(self.timeline).filter(function(i){return $(this).attr('start') > time;}).eq(0);
				}else{
					self.line = $(self.timeline).filter(function(i){return $(this).attr('start') > time;}).eq(0);
				}

				
        var content = self.getNextContent(); // Now it checks conditions if defined.
				
        var delay = 1000;
        if(self.line.length > 0){
            self.last_time = parseInt(self.line.attr("start"));
						delay = parseInt(self.last_time)*1000 - milliseconds_of_the_day;
        }else{
						var load_future_data = false;
						if(self.synchronizer){
								if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
									load_future_data = true;
								}
						}else{
							load_future_data = true;
						}
						if(load_future_data){
							self.log("Reached End Of The Day !");
	            delay = 86400 - self.last_time;
							delay = delay * 1000;
	            self.last_time = 0;
	            last = parseInt(self.last_time);
	            if(self.future_data && self.timeline.length > 0){
	                self.log("Searching next day");
	                self.timeline = $(self.future_data.reader.timeline()).find("content");
	                self.line = $(self.timeline).filter(function(i){return $(this).attr('start') >= last;}).eq(0);
	                if(self.line.length > 0){
	                    content = self.future_data.getArchiveFileItemById(self.line.attr("id"));
											
	                }
									self.notifyError(self.ERROR['EXCEPTION'],self.name+" ["+(new Date().getTime())+"] | ["+self.getDate().getTime()+" - "+self.getDate().getTimezoneOffset()+"]: Reached End Of The Day : Loading content : "+content);
	          	}else{
	                self.log("Timeline is emtpy or future data could not be loaded.");
	                self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+5,self.name+": ["+(new Date().getTime())+"] | ["+self.getDate().getTime()+" - "+self.getDate().getTimezoneOffset()+"]: Timeline is emtpy or future data could not be loaded.");
									delay = self.scene.content.content.getDuration();
									delay = delay * 1000;
	            }
						}
        }
				if(!self.synchronizer){
					if(delay > self.rendering.content.content.getDuration()*1000){
						content = false;
						delay = self.rendering.content.content.getDuration()*1000;
					}
				}

				var content_type = "";
        if(content){
            if(content.verify(self.getDate(true).getTime())){
                    if(self.verify_campaign(self.line)){
                        var display_object_reference = self.addContent(content);
                        if(display_object_reference){
                            var DisplayContentElement = self.renderer.getDisplayContentElement(display_object_reference);
														content_type = DisplayContentElement.type;
                            self.renderer.checkAvailability(display_object_reference);
                            if(DisplayContentElement.available && !DisplayContentElement.invalidated){
                                self.toberendered = content.getId();
                                var timeline_template_id = self.getTemplate();
                                var timeline_duration = parseInt(self.line.attr("duration"));
                                if(!isNaN(timeline_template_id) && timeline_template_id > 0){
                                    var template_element = self.data.getTemplateById(timeline_template_id);
                                    if(template_element){
                                        template_element.loadTemplateContentItems(self.data,self.conditional);
                                        self.template = self.addDisplayTemplate(template_element);
                                    }
                                }else{
                                    self.template = null;
                                    self.template = false;
                                }
																
                                self.log("Found At -> "+in_time+" SoD:"+self.last_time+" Content : "+self.line.attr("id")+" Duration : "+timeline_duration);
                                self.log("Playing in : "+delay+"s with template : "+self.line.attr("template_id"));
                                self.scene = null;
                                self.scene = self.renderer.prepare_scene(self.template,self.toberendered,false);
                            }else{
																self.scene = null;
                                self.scene = self.renderer.prepare_scene(false,self.toberendered,false);
                                self.log("Content not available yet - Next check in : "+delay+"s");
																if(self.platform !== "SOC"){
																	if(DisplayContentElement.invalidated){
																		DisplayContentElement.updatePath();
																		DisplayContentElement.invalidated = false;
																	}
																}
                            }
                        }else{
														self.scene = null;
                            self.scene = self.renderer.prepare_scene(false,self.toberendered,false);
                            self.log("Unable to create Display Object - Next check in : "+delay+"s");
                        }
                    }else{
												self.scene = null;
                        self.scene = self.renderer.prepare_scene(false,self.toberendered,false);
                        self.log("Campaign Expired - Next check in : "+delay+"s");
                        self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+3,self.name+": Campaign Expired: Content "+self.line.attr("id")+" is out of campaign range.");
                    }
            }else{
								self.scene = null;
                self.scene = self.renderer.prepare_scene(false,self.toberendered,false);
                self.log("Content Expired or Not Active yet - Next check in : "+delay+"s");
                self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+4,self.name+": Content Expired or Not Active yet: Content "+self.line.attr("id")+" is out of date range.");
            }
        }else{
						self.scene = null;
            self.scene = self.renderer.prepare_scene(false,self.toberendered,false);
            self.log("No content found - Next check in : "+delay+"s");
        }
				
				if(self.previous_current_time > 0){
					delay = 10;
				}
				
				clearTimeout(self.timer);
				if(synchronizer_time == -1){
					if(self.platform == "SOC" && delay < 4000){
						self.log("Delay is lower then 4s : re-prepare");
						self.timer = setTimeout(self.main,4000);
					}else if(delay < 2000){
						self.log("Delay is lower then 2s : re-prepare");
						self.timer = setTimeout(self.main,2000);
					}else{
						self.log("Benchmark Delay to next render : "+delay);
						self.timer = setTimeout(self.main,delay);
					}
				}
				
				self.OS.busy = false;
				self.prepared = true;

				if(self.synchronizer){
						if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
								self.log("Master Send Broadcast Preload !! Actual index :"+self.index);
								var broadcast_message = {
									sender:self.name,
									action:{
										do:"preload",
										index:time,
										time:self.getDate().getTime(),
										player_id:self.player_id
									}
								};
								self.synchronizer.broadcast(broadcast_message);
								broadcast_message = null;
						}
				}
    };
		
		this.getNextContent = function(){
			var content = self.data.getArchiveFileItemById(self.line.attr("id"));
			try{
				var conditions = false;
				if(self.conditional.data){
					var condition_group_id = self.line.attr("condition_group_id");
					if(condition_group_id !== "0"){
						var xml_conditions = $(self.data.reader.timeline()).find("conditions[id='"+condition_group_id+"']");
						if(typeof(xml_conditions) !== "undefined"){
							conditions = self.conditional.createConditionsObject(xml_conditions);
							if(conditions){
								var satisfies = self.conditional.checkConditions(conditions);
								if(satisfies >= 0){
									if(conditions[satisfies].action == 2){ // Action File Replace
										self.log("Content : "+self.line.attr("id")+" modified by condition to : "+conditions[satisfies].value);
										content = self.data.getArchiveFileItemById(conditions[satisfies].value);
									}
								}
							}
						}
					}
				}
			}catch(e){
				self.log("Function getNextContent() failed : unable to read conditions or no conditions defined");
				self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+6,self.name+": Function getNextContent() failed : unable to read conditions or no conditions defined ");
			}
			return content;
		};
		
		this.getTemplate = function(){
			var timeline_template_id = parseInt(self.line.attr("template_id"));
			try{
				var conditions = false;
				if(self.conditional){
						conditions = self.conditional.createConditionsObject($(self.line).find("conditions"));
						if(conditions){
							var satisfies = self.conditional.checkConditions(conditions);
							if(satisfies >= 0){
								if(conditions[satisfies].action == 3){ // Template Replace
									self.log("Template : "+timeline_template_id+" modified by condition to : "+conditions[satisfies].value);
									timeline_template_id = conditions[satisfies].value;
								}
							}
						}
				}
			}catch(e){
				self.log("Function getTemplate() failed : unable to read conditions or no conditions defined");
				self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+6,self.name+": Function getTemplate() failed : unable to read conditions or no conditions defined ");
			}

			return timeline_template_id;
		};

    this.stop = function(){
        self.active = false;
        self.log("<<<<<<< STOP >>>>>>");
        clearTimeout(self.timer);
				clearTimeout(self.security_timer);
        $(self.renderer).off("DisplayControllerElementStarted");
        $(self.renderer).off("DisplayControllerElementError");
    };

    this.addContent = function(ContentElement){
        var displayObjectRef = false;
        displayObjectRef = self.renderer.addDisplayElement(ContentElement);
        if(!displayObjectRef){
            self.log("no display object for content : "+ContentElement.getSource());
            self.notifyError(self.ERROR['TIMELINE_CONTROLLER']+1,self.name+": Function addContent() failed : no display object for content : "+ContentElement.getSource());
        }else{
					self.renderer.checkAvailability(displayObjectRef);
				}
        return displayObjectRef;
    };

    this.addDisplayTemplate = function(TemplateElement){
        var id = 0;
        if(TemplateElement){
            var id = self.execute(function(){return TemplateElement.getId();});
            if(id){
                id = parseInt(id);
            }
        }
        if(id > 0){
            if(typeof(self.renderer.template_elements[id]) !== "undefined"){
                // TODO : IMPROVE
                var prev = ""+$(self.renderer.template_elements[id].data.data)[0].outerHTML;
                var post = ""+$(TemplateElement.data)[0].outerHTML;
                if(prev != post){
                    //self.renderer.template.unload(id); // OLD TODO: review template.unload()
                    self.renderer.template.unload();
                    self.renderer.template_elements[id].data = TemplateElement;
                    self.renderer.template.load();
                }
            }else{
                self.renderer.template_elements[id] = null;
                self.renderer.template_elements[id] = new DisplayTemplate(TemplateElement,self.renderer,self.conditional);
            }
        }
        return id;
		};

    this.jump = function(index){
        self.log("No action jump available");
    };

    this.reportStatus = function(){
        self.rendering.content.campaign_id = $(self.data.reader.timeline()).find("content[start='"+self.last_time+"']").attr("campaign_id");
        var stats_conditions = "";
        if(self.conditional){
            stats_conditions = self.conditional.createConditionsStat(self.data.getStats().getConditionStats());
        }
        self.OS.id_content_now = self.rendering.content.reference;
        self.data.reportStatistics(self.rendering.content.reference,self.rendering.content.campaign_id,stats_conditions);
        //self.OS.writeFile("admira.status",self.rendering.content.reference+":"+self.pass+":"+self.playlist_id+":"+self.version);
    };

    this.verify_campaign = function(line){
        var is_active = true;
        var campaign_id = $(line).attr('campaign_id');
        if(campaign_id){
            if(campaign_id != "" && campaign_id != "0"){
                var expiration = self.getDate(self.server_time_activated,2147483647000);
                var temp_expiration = $(line).attr('expiration');
                var day = parseInt(temp_expiration.split("-")[0]);
                var month = parseInt(temp_expiration.split("-")[1])-1;
                var year = parseInt(temp_expiration.split("-")[2]);
                if(self.server_time_activated){
                    expiration.setUTCFullYear(year);
                    expiration.setUTCMonth(month);
                    expiration.setUTCDate(day);
                }else{
                    expiration.setFullYear(year);
                    expiration.setMonth(month);
                    expiration.setDate(day);
                }
                expiration = expiration.getTime()+86399000; // Add the 86400 seconds of the entire day -1sec
                var now = self.getDate().getTime();
                if(isNaN(expiration)){
                    is_active = true;
                }else{
                    if(expiration > now){
                        is_active = true;
                    }else{
                        is_active = false;
                    }
                }
            }
        }
        return is_active;
    };

    this.prepare_next_day = function(){
        var dow = self.getDate().getDay();
        dow+=1;
        if(dow == 0) dow = 7;
        if(dow == 8) dow = 1;

        var url = self.rootDir+self.ROUTES['XML'].path+dow+".xml";
        if(self.platform == "CHROMEOS"){
              url = self.OS.fs.root.toURL()+self.rootDir+self.ROUTES['XML'].path+dow+".xml";
        }else{
              url = self.OS.rootDir+self.ROUTES['XML'].path+dow+".xml";
        }
        self.future_data = null;
        self.future_data = new DataManagerController();
        self.future_data.load(url,-1);
        $(self.future_data).one("DataManagerControllerDataLoaded",self.onDataLoaded);
				self.notifyError(self.ERROR['EXCEPTION'],self.name+" ["+(new Date().getTime())+"] | ["+self.getDate().getTime()+" - "+self.getDate().getTimezoneOffset()+"]: Trying to Load XML Future Data dow : "+dow+" from url : "+url);
    };

    this.onDataLoaded = function(){
        self.log("Next day ready");
				self.notifyError(self.ERROR['EXCEPTION'],self.name+" : Done on loading Load XML Future Data");
    };

    this.onConditionTrigger = function(e,interruption,condition){
        self.log("Prepare Trigger Action : "+condition.action+" Value : "+condition.value+" Interrupts : "+interruption);
    };

		this.onSyncRecieve = function(event,action){
				if(action.player_id == ""+self.synchronizer.master_server_id){
					if(action.do == "play"){
							self.log("<#> Play ! Index = "+self.index);
							self.main(false);
					}else if(action.do == "preload"){
							self.log("<#> Actual Index = "+self.index+" Want to preload index = "+action.index);
							if(action.index != self.index){
									self.log("<#> Index updated to : "+action.index);
									self.index = parseInt(action.index);
							}
							self.log("<#> Checknext for: "+action.index);
							self.prepare(false,action.index);
					}else if(action.do == "condition"){
							self.log("<#> Set condition from MASTER");
							self.conditional.onNewConditionValue(action.condition,false);
					}
				}else if(action.do == "slave_condition" && action.player_id != self.player_id){
						self.log("<#> Set condition from SLAVE");
						self.conditional.onNewConditionValue(action.condition,false);
				}
				if(!self.active && self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
						self.start();
				}else if(self.active && self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
						self.log("I'm SLAVE stop autoplaylist playback");
						self.stop();
				}
		};

		this.onStatusSyncRecieve = function(event,action){
				if(!self.active && self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
						self.start();
				}
		};

		this.onSyncModeChanged = function(){
				self.log("Sync Mode Changed to : "+self.synchronizer.using_mode);
				$(self.synchronizer).off("on"+self.name+"SyncRecieve",self.onSyncRecieve);
				$(self.synchronizer).off("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
				$(self.synchronizer).off("onStatusSyncRecieve",self.onStatusSyncRecieve);
				$(self.synchronizer).on("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
				if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
						self.stop();
						$(self.synchronizer).on("on"+self.name+"SyncRecieve",self.onSyncRecieve);
				}else if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
						$(self.synchronizer).on("onStatusSyncRecieve",self.onStatusSyncRecieve);
						self.stop();
						self.prepare();
						self.start();
				}
		};
				
		this.getInfo = function(){
				var info = {
					rendering:{
						content_id: self.rendering.content.reference,
						die: self.rendering.die,
						type: self.rendering.content.type,
						rect: self.rendering.rectangle,
						tag: self.rendering.tag,
						template_id: self.rendering.template_ref,
						layer: self.rendering.content.layer,
						campaign_id: self.rendering.content.campaign_id
					},
					scene:{
						content_id: self.scene.content.reference,
						die: self.scene.die,
						type: self.scene.content.type,
						rect: self.scene.rectangle,
						tag: self.scene.tag,
						template_id: self.scene.template_ref,
						layer: self.scene.content.layer
					},
					timeline:{
						index: self.last_time
					}
				};
				return info;
		};

}
TimelineController.prototype = new SystemController();
